/*
 * ImageFilter.java
 * and open the template in the editor.
 */

package wsq_sun_java;

import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;
import wsq_sun_java.FileFilterType;



public class ImageFilter {
    
    public static FileFilter AllImage_Filter() {
        return new FileFilterType() {
            public boolean accept(File f) {
                if (null == f) {
                    return false;
                }
                if (f.isDirectory()) {
                    return true;
                }
                
                String extension = getExtension(f);
                if (extension != null) {
                    extension = extension.toLowerCase();
                    if (
                        extension.equals("wsq") || extension.equals("bmp")  ||
                        extension.equals("tiff") || extension.equals("tif") ||
                        extension.equals("gif") || extension.equals("jpeg") ||
                        extension.equals("jpg") || extension.equals("tga") ||
                        extension.equals("png") || extension.equals("iff") ||                        
                        extension.equals("rgb") || extension.equals("psd") ||
                        extension.equals("cel") ||extension.equals("pcx") 
                       )    
                    {
                        return true;
                    } else {
                        return false;
                    }
                }
                
                return false;
            }
            
            public String getDescription() {
                return "All Images";
            }
            
            public int type() {
                return 0;
            }
        };
    }
    
    public static FileFilter WSQ_Filter() {
        return new FileFilterType() {
            public boolean accept(File f) {
                if (null == f) {
                    return false;
                }
                if (f.isDirectory()) {
                    return false;
                }
                
                String extension = getExtension(f);
                if (null == extension) {
                    return false;
                }
                extension = extension.toLowerCase();
                if (extension.equals("wsq")) {
                    return true;
                }
                return false;
            }
        
            public String getDescription() {
                return "FBI Wavelet Scalar Quantization (*.wsq)";
            }
            
            public int type() {
                return 1;
            }
        };
    }
    
    public static FileFilter BMP_Filter() {
        return new FileFilterType() {
            public boolean accept(File f) {
                if (null == f) {
                    return false;
                }
                if (f.isDirectory()) {
                    return false;
                }
                
                String extension = getExtension(f);
                if (null == extension) {
                    return false;
                }
                extension = extension.toLowerCase();
                if (extension.equals("bmp")) {
                    return true;
                }
                return false;
            }
        
            public String getDescription() {
                return "Windows BMP (*.bmp)";
            }
            
            public int type() {
                return 2;
            }
        };
    }
    
    public static FileFilter TIFF_Filter() {
        return new FileFilterType() {
            public boolean accept(File f) {
                if (f.isDirectory()) {
                    return false;
                }
                
                String extension = getExtension(f);
                extension = extension.toLowerCase();
                if (extension.equals("tiff")) {
                    return true;
                }
                return false;
            }
        
            public String getDescription() {
                return "Macintosh TIFF Files (*.tiff)";
            }
            
            public int type() {
                return 3;
            }
        };
    }
    
    public static FileFilter PNG_Filter() {
        return new FileFilterType() {
            public boolean accept(File f) {
                if (f.isDirectory()) {
                    return false;
                }
                
                String extension = getExtension(f);
                extension = extension.toLowerCase();
                if (extension.equals("png")) {
                    return true;
                }
                return false;
            }
        
            public String getDescription() {
                return "Portable network graphic images (*.png)";
            }
            
            public int type() {
                return 4;
            }
        };
    }
    
    public static FileFilter JPEG_Filter() {
        return new FileFilterType() {
            public boolean accept(File f) {
                if (f.isDirectory()) {
                    return false;
                }
                
                String extension = getExtension(f);
                extension = extension.toLowerCase();
                if (extension.equals("jepg") ||
                    extension.equals("jpg")) {
                    return true;
                }
                return false;
            }
        
            public String getDescription() {
                return "JPEG Files (*.jpeg, *.jpg)";
            }
            
            public int type() {
                return 5;
            }
        };
    }
    
    public static FileFilter TARGA_Filter() {
        return new FileFilterType() {
            public boolean accept(File f) {
                if (f.isDirectory()) {
                    return false;
                }
                
                String extension = getExtension(f);
                extension = extension.toLowerCase();
                if (extension.equals("tga")) {
                    return true;
                }
                return false;
            }
        
            public String getDescription() {
                return "Targa Files (*.tga)";
            }
            
            public int type() {
                return 6;
            }
        };
    }
    

    public static FileFilter TIF_Filter() {
        return new FileFilterType() {
            public boolean accept(File f) {
                if (null == f) {
                    return false;
                }
                if (f.isDirectory()) {
                    return false;
                }
                
                String extension = getExtension(f);
                if (null == extension) {
                    return false;
                }
                extension = extension.toLowerCase();
                if (extension.equals("tif")) {
                    return true;
                }
                return false;
            }
        
            public String getDescription() {
                return "PC TIFF images (*.tif)";
            }
            
            public int type() {
                return 7;
            }
        };
    }
    
    
    public static FileFilter GIF_Filter() {
        return new FileFilterType() {
            public boolean accept(File f) {
                if (null == f) {
                    return false;
                }
                if (f.isDirectory()) {
                    return false;
                }
                
                String extension = getExtension(f);
                if (null == extension) {
                    return false;
                }
                extension = extension.toLowerCase();
                if (extension.equals("gif")) {
                    return true;
                }
                return false;
            }
        
            public String getDescription() {
                return "Compuserve Graphic Interchange Format(*.gif)";
            }
            
            public int type() {
                return 8;
            }
        };
    }
    
    
    public static FileFilter TGA_Filter() {
        return new FileFilterType() {
            public boolean accept(File f) {
                if (f.isDirectory()) {
                    return false;
                }
                
                String extension = getExtension(f);
                extension = extension.toLowerCase();
                if (extension.equals("tga")) {
                    return true;
                }
                return false;
            }
        
            public String getDescription() {
                return "Truevision images (*.tga)";
            }
            
            public int type() {
                return 9;
            }
        };
    }
    
    
    public static FileFilter PCX_Filter() {
        return new FileFilterType() {
            public boolean accept(File f) {
                if (f.isDirectory()) {
                    return false;
                }
                
                String extension = getExtension(f);
                extension = extension.toLowerCase();
                if (extension.equals("pcx")) {
                    return true;
                }
                return false;
            }
        
            public String getDescription() {
                return "ZSoft Paintbrush images (*.pcx)";
            }
            
            public int type() {
                return 10;
            }
        };
    }
    
    
    public static FileFilter RGB_Filter() {
        return new FileFilterType() {
            public boolean accept(File f) {
                if (f.isDirectory()) {
                    return false;
                }
                
                String extension = getExtension(f);
                extension = extension.toLowerCase();
                if (extension.equals("rgb")) {
                    return true;
                }
                return false;
            }
        
            public String getDescription() {
                return "SGI true color images (*.rgb)";
            }
            
            public int type() {
                return 11;
            }
        };
    }
    
    
    public static FileFilter PSD_Filter() {
        return new FileFilterType() {
            public boolean accept(File f) {
                if (f.isDirectory()) {
                    return false;
                }
                
                String extension = getExtension(f);
                extension = extension.toLowerCase();
                if (extension.equals("psd")) {
                    return true;
                }
                return false;
            }
        
            public String getDescription() {
                return "Photoshop images (*.psd)";
            }
            
            public int type() {
                return 12;
            }
        };
    }
    
    
    public static FileFilter CEL_Filter() {
        return new FileFilterType() {
            public boolean accept(File f) {
                if (f.isDirectory()) {
                    return false;
                }
                
                String extension = getExtension(f);
                extension = extension.toLowerCase();
                if (extension.equals("cel")) {
                    return true;
                }
                return false;
            }
        
            public String getDescription() {
                return "Autodesk images (*.cel)";
            }
            
            public int type() {
                return 13;
            }
        };
    }
    
    
    public static FileFilter IFF_Filter() {
        return new FileFilterType() {
            public boolean accept(File f) {
                if (f.isDirectory()) {
                    return false;
                }
                
                String extension = getExtension(f);
                extension = extension.toLowerCase();
                if (extension.equals("iff")) {
                    return true;
                }
                return false;
            }
        
            public String getDescription() {
                return "Amiga Bitmap Graphic (8 bits)|*.iff";
            }
            
            public int type() {
                return 14;
            }
        };
    }

    
    public static String getExtension(File f) {
        String ext = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1) {
            ext = s.substring(i+1).toLowerCase();
        }
        return ext;
    }
}
